=encoding utf8

=head1 NAME

Mail::Message::Head::SpamGroup - spam fighting related header fields

=head1 INHERITANCE

 Mail::Message::Head::SpamGroup
   is a Mail::Message::Head::FieldGroup
   is a Mail::Reporter

=head1 SYNOPSIS

  my $sg = Mail::Message::Head::SpamGroup->new(head => $head, ...);
  $head->addSpamGroup($sg);

  my $sg = $head->addSpamGroup( <options> );
  $sg->delete;

  my @sgs = $head->spamGroups;

=head1 DESCRIPTION

A I<spam group> is a set of header fields which are added by spam detection
and spam fighting software.  This class knows various details about
that software.

Extends L<"DESCRIPTION" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"DESCRIPTION">.

=head1 METHODS

Extends L<"METHODS" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"Constructors">.

=over 4

=item $obj-E<gt>B<clone>()

Inherited, see L<Mail::Message::Head::FieldGroup/"Constructors">

=item $any-E<gt>B<fighter>($name, %options)

Get the settings of a certain spam-fighter, optionally after setting them.
The L<knownFighters()> method returns the defined names.  The names
are case-sensitive.

The C<%options> are all passed as settings to the spamfilter, except the
few which are listed here specifically.

 -Option --Default
  fields   <required>
  isspam   <required>
  version  undef

=over 2

=item fields => REGEXP

The regular expression which indicates which of the header fields are
added by the spam fighter software.

=item isspam => CODE

The CODE must return C<true> or C<false>, to indicate whether the spam fighter
thinks that the message contains spam.  The CODE ref is called with
the spamgroup object (under construction) and the header which is inspected.

=item version => CODE

Can be called to collect the official name and the version of the
software which is used to detect spam.  The CODE ref is called with
the spamgroup object (under construction) and the header which is inspected.

=back

» example: adding your own spam-fighter definitions

  Mail::Message::Head::SpamGroup->fighter( 'MY-OWN',
     fields => qw/^x-MY-SPAM-DETECTOR-/,
     isspam => sub { my ($sg, $head) = @_; $head->fields > 100 },
  );

=item $obj-E<gt>B<from>($head|$message, %options)

Returns a list of C<Mail::Message::Head::SpamGroup> objects, based on the
specified C<$message> or message C<$head>.
Improves base, see L<Mail::Message::Head::FieldGroup/"Constructors">

 -Option--Default
  types   undef

=over 2

=item types => ARRAY-OF-NAMES

Only the specified types will be tried.  If the ARRAY is empty, an empty
list is returned.  Without this option, all sets are returned.

=back

=item $any-E<gt>B<habeasSweFieldsCorrect>( [$message|$head] )

Returns a C<true> value if the C<$message> or C<$head> contains C<Habeas-SWE> fields
which are correct.  Without argument, this is used as instance method on
an existing Spam-Group.

» example: checking Habeas-SWE fields

  if(Mail::Message::Head::SpamGroup->habeasSweFieldsCorrect($message))
  {   $message->label(spam => 0);
  }

  my $sg = $message->head->spamGroups('Habeas-SWE');
  if($sg->habeasSweFieldsCorrect) { ... };

  use List::Util 'first';
  if(first {$_->habeasSweFieldsCorrect} $head->spamGroups)
  {   ...
  }

=item $any-E<gt>B<implementedTypes>()

Inherited, see L<Mail::Message::Head::FieldGroup/"Constructors">

=item $any-E<gt>B<isSpamGroupFieldName>($name)

Z<>

=item $any-E<gt>B<knownFighters>()

Returns an unsorted list of all names representing pre-defined spam-fighter
software.  You can ask details about them, and register more fighters with
the L<fighter()|Mail::Message::Head::SpamGroup/"Constructors"> method.

=item $class-E<gt>B<new>($fields, %options)

Construct an object which maintains one set of fields which were added
by spam fighting software.
Improves base, see L<Mail::Message::Head::FieldGroup/"Constructors">

 -Option  --Defined in                     --Default
  head      Mail::Message::Head::FieldGroup  undef
  software  Mail::Message::Head::FieldGroup  undef
  type      Mail::Message::Head::FieldGroup  undef
  version   Mail::Message::Head::FieldGroup  undef

=over 2

=item head => $head

=item software => STRING

=item type => STRING

=item version => STRING

=back

=item $obj-E<gt>B<spamDetected>( [BOOLEAN] )

Returns (after setting) whether this group of spam headers thinks that
this is spam.  See L<Mail::Message::Head::Complete::spamDetected()|Mail::Message::Head::Complete/"Access to the header">.

» example: 

  die if $head->spamDetected;

  foreach my $sg ($head->spamGroups)
  {   print $sg->type." found spam\n" if $sg->spamDetected;
  }

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"Attributes">.

=head2 The header

Extends L<"The header" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"The header">.

=over 4

=item $obj-E<gt>B<add>( <$field, $value> | $object )

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=item $obj-E<gt>B<addFields>( [$fieldnames] )

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=item $obj-E<gt>B<attach>($head)

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=item $obj-E<gt>B<delete>()

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=item $obj-E<gt>B<fieldNames>()

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=item $obj-E<gt>B<fields>()

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=item $obj-E<gt>B<head>()

Inherited, see L<Mail::Message::Head::FieldGroup/"The header">

=back

=head2 Access to the header

Extends L<"Access to the header" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"Access to the header">.

=over 4

=item $obj-E<gt>B<software>()

Inherited, see L<Mail::Message::Head::FieldGroup/"Access to the header">

=item $obj-E<gt>B<type>()

Inherited, see L<Mail::Message::Head::FieldGroup/"Access to the header">

=item $obj-E<gt>B<version>()

Inherited, see L<Mail::Message::Head::FieldGroup/"Access to the header">

=back

=head2 Internals

Extends L<"Internals" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"Internals">.

=over 4

=item $obj-E<gt>B<collectFields>( [$name] )

Inherited, see L<Mail::Message::Head::FieldGroup/"Internals">

=item $obj-E<gt>B<detected>($type, $software, $version)

Inherited, see L<Mail::Message::Head::FieldGroup/"Internals">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<details>()

Inherited, see L<Mail::Message::Head::FieldGroup/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<print>( [$fh] )

Inherited, see L<Mail::Message::Head::FieldGroup/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Message::Head::FieldGroup|Mail::Message::Head::FieldGroup/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Reporter/"Cleanup">

=back

=head1 DIAGNOSTICS

=over 4

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=back

=head1 SEE ALSO

This module is part of Mail-Message version 4.05,
built on April 10, 2026. Website: F<http://perl.overmeer.net/mailbox/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

